---
title: JavaScript Module Examples
author: Dr. Greg M. Bernstein
---

# JavaScript Module Examples

To demonstrate JavaScript modules the following examples are furnished:

* Browser based ES6 modules
* Node.js based ES6 modules
* Node.js CommonJS modules
* Bundler ES6 modules via Parcel.js

## Browser based ES6 Module Example

Files: `conditions.js`, `foilGear.js`, `index.html`, `waveGear.js`

**Requires**: A web server. I've used the Node.js/NPM `http-server` successfully.

## Node.js with ES6 Modules Example

Files: `conditions.mjs`, `foilGear.mjs`, `waveGear.mjs`, and `nodeES6Ex.mjs`

**Requires**: Node.js version 14 or greater

## Node.js with CommonJS Modules Example

Files: `exampleCJS.js` (main), `simpleCJSa.js`, `simpleCJSb.js`, `simpleCJSc.js`

**Requires**: Node.js

## Bundler ES6 Module Example

See directory `BundlerEx` and its contents.

For development: `parcel index.html`, but this doesn't really demonstrate much.

For deployment: `parcel build index.html --public-url ./` then look in the `dist`subdirectory.